<script>
  // @ts-nocheck

  import back from "../../plugins/axios";
  import SvelteMarkdown from "svelte-markdown";
  let backurl = import.meta.env.VITE_BACKEND;

  /**
   * @type {any[]}
   */
  let streamers = [];
  let file_inputs = {};
  let images = {};
  let alerts = {};
  let successes = {};
  let alert = "";
  let success = "";

  back.get("/streamers").then((res) => {
    streamers = res.data;
    console.log(streamers);
  });

  function update_image(id) {
    // back put the image on /website/logo
    let formData = new FormData();
    // @ts-ignore
    formData.append("image_file", file_inputs[id].files[0]);
    back.put("/streamers/" + id + "/image", formData).then((rep) => {
      if (rep.status == 200) {
        for (let i = 0; i < streamers.length; i++) {
          if (streamers[i].id == id) {
            streamers[i].image_file = rep.data.image_file;
          }
        }
        // images[id].src = backurl + rep.data.image_file.slice(1);
        successes[id] = "Image mise à jour !";
        alerts[id] = "";
      } else {
        alerts[id] = "Erreur lors de la mise à jour de l'image";
        successes[id] = "";
      }
      setTimeout(() => {
        alerts[id] = "";
        successes[id] = "";
      }, 5000);
    });
  }

  function delete_streamer(id) {
    back.delete("/streamers/" + id).then((rep) => {
      if (rep.status == 200) {
        streamers = streamers.filter((streamer) => streamer.id != id);
      } else {
        alerts[id] = "Erreur lors de la suppression du streamer";
        successes[id] = "";
        setTimeout(() => {
          alerts[id] = "";
          successes[id] = "";
        }, 5000);
      }
    });
  }

  function update_streamer(id) {
    let index = streamers.findIndex((streamer) => streamer.id == id);
    let streamer = streamers[index];
    if (streamer.twitch_id) {
        streamers[index].twitch_id = streamers[index].twitch_id.toLowerCase().replace(" ", "_");
    }

    let data = {
        name: streamer.name,
        description: streamer.description,
        twitch_id: streamer.twitch_id
    }
    back.put("/streamers/" + streamer.id, data).then((rep) => {
      if (rep.status == 200) {
        successes[id] = "Streamer mis à jour !";
        alerts[id] = "";
      } else {
        alerts[id] = "Erreur lors de la mise à jour du streamer";
        successes[id] = "";
      }
    });
  }

  function add_streamer() {
    back
      .post("/streamers", {
        name: "Nouveau streamer " + streamers.length,
        description: "Description par défaut",
        twitch_id: "identifiant" + streamers.length,
      })
      .then((rep) => {
        if (rep.status == 200) {
          streamers.push(rep.data);
          // force rerender
          streamers = streamers;
          success = "Streamer créé !";
          alert = "";
        } else {
          alert = "Erreur lors de la création du streamer";
          successe = "";
        }
        setTimeout(() => {
          alert = "";
          successe = "";
        }, 5000);
      });

    // scroll everything to the bottom
    setTimeout(() => {
      for (let i = 0; i < streamers.length; i++) {
        document.getElementById("streamer_" + streamers[i].id).scrollIntoView();
      }
    }, 100);
  }
</script>

<h2 class="card-title text-4xl">Streamers</h2>
{#if alert}
  <div
    class="fixed top-32 opacity-75 bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded mt-2 mb-2"
    role="alert"
  >
    <strong class="font-bold">Erreur !</strong>
    <span class="block sm:inline">{alert}</span>
  </div>
{/if}
{#if success}
  <div
    class="fixed top-32 opacity-75 bg-green-100 border border-green-400 text-green-700 px-4 py-3 rounded mt-2 mb-2"
    role="alert"
  >
    <strong class="font-bold">Succès !</strong>
    <span class="block sm:inline">{success}</span>
  </div>
{/if}
<div class="grid grid-cols-3 gap-5 mt-5">
  {#each streamers as streamer}
    <div
      class="w-full h-full max-w-md items-center self-center"
      id="streamer_{streamer.id}"
    >
      <form
        class="bg-secondary h-full shadow-md items-center rounded px-8 pt-6 pb-8 mb-4"
      >
        <div class="mb-4">
          <label class="block text-gray-700 text-md font-bold mb-2" for="name">
            {streamer.name}
          </label>
        </div>
        <div class="mb-4 ">
          <label class=" text-gray-700 text-sm font-bold mb-2" for="name">
            Nom :
          </label>
          <input
            class="shadow appearance-none border rounded w-1/2 py-2 px-3 text-gray-700 leading-tight focus:shadow-outline"
            id="name"
            type="text"
            placeholder={streamer.name}
            bind:value={streamer.name}
          />
        </div>
        <div class="mb-4 ">
          <label class="text-gray-700 text-sm font-bold mb-2" for="name">
            Twitch ID :
          </label>
          <input
            class="shadow appearance-none border rounded w-1/2 py-2 px-3 text-gray-700 leading-tight focus:shadow-outline"
            id="name"
            type="text"
            placeholder={streamer.twitch_id}
            bind:value={streamer.twitch_id}
          />
        </div>
        <div class="mb-4">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Description :
          </label>
          <textarea
            class="shadow appearance-none border rounded w-full h-56 py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="name"
            placeholder={streamer.description}
            bind:value={streamer.description}
          />
        </div>

        <div class="mb-4">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Image :
          </label>
          <!-- file -->
          <div class="flex items-center justify-center w-full">
            <label
              class="flex flex-col border-4 border-dashed w-full h-32 hover:bg-gray-100 hover:border-purple-300 group"
            >
              <div class="flex flex-col items-center justify-center pt-7">
                <svg
                  class="w-10 h-10 text-purple-400 group-hover:text-purple-600"
                  fill="none"
                  stroke="currentColor"
                  viewBox="0 0 48 48"
                  xmlns="http://www.w3.org/2000/svg"
                >
                  <path
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M14 44v-8a2 2 0 012-2h20a2 2 0 012 2v8m-4-4h-4m-8 0H6"
                  />
                  <path
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M14 34l7-7 7 7m-7-7v18"
                  />
                </svg>
                <p
                  class="lowercase text-sm text-gray-400 group-hover:text-purple-600 pt-1 tracking-wider"
                >
                  Choisir un fichier
                </p>
              </div>
              <input
                type="file"
                class="hidden"
                bind:this={file_inputs[streamer.id]}
                accept="image/*"
              />
            </label>
          </div>
        </div>
        <div class="mb-4">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Aperçu :
          </label>
          <img
            width="100px"
            height="100px"
            bind:this={images[streamer.id]}
            src="{backurl}{streamer.image_file.slice(1)}"
            alt="Logo manquant"
          />
          {#if streamer.description}
            <SvelteMarkdown source={streamer.description} />
          {/if}
        </div>
        <!-- alert & success -->
        {#if alerts[streamer.id]}
          <div
            class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative mt-2 mb-2"
            role="alert"
          >
            <strong class="font-bold">Erreur !</strong>
            <span class="block sm:inline">{alerts[streamer.id]}</span>
          </div>
        {/if}
        {#if successes[streamer.id]}
          <div
            class="bg-green-100 border border-green-400 text-green-700 px-4 py-3 rounded relative mt-2 mb-2"
            role="alert"
          >
            <strong class="font-bold">Succès !</strong>
            <span class="block sm:inline">{successes[streamer.id]}</span>
          </div>
        {/if}
        <div class="grid grid-cols-3 justify-between">
          <button
            class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
            type="button"
            on:click={update_streamer(streamer.id)}
          >
            Mettre à jour
          </button>
          <button
            class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
            type="button"
            on:click={update_image(streamer.id)}
          >
            Envoyer l'image
          </button>
          <button
            class="bg-red-500 hover:bg-red-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
            type="button"
            on:click={delete_streamer(streamer.id)}
          >
            Supprimer
          </button>
        </div>
      </form>
    </div>
  {/each}

  <!-- Add button -->
  <div class="fixed bottom-0 right-0 m-4">
    <button
      class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded-full focus:outline-none focus:shadow-outline"
      type="button"
      on:click={add_streamer}
    >
      <svg
        class="w-8 h-8"
        fill="none"
        stroke="currentColor"
        viewBox="0 0 24 24"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M12 6v6m0 0v6m0-6h6m-6 0H6"
        />
      </svg>
    </button>
  </div>
</div>
